package compute

import (
	"context"
	"net/http"
	"strconv"

	"repository.basistech.ru/BASIS/decort-golang-sdk/internal/validators"
)

// DiskSwitchToReplicationRequest struct to switch disk to it's replication
type DiskSwitchToReplicationRequest struct {
	// ID of compute instance
	// Required: true
	ComputeID uint64 `url:"computeId" json:"computeId" validate:"required"`

	// ID of the disk to switch
	// Required: true
	DiskID uint64 `url:"diskId" json:"diskId" validate:"required"`

	// Delete replication relationship
	// Required: false
	StopReplication bool `url:"stopReplication" json:"stopReplication"`
}

type wrapperDiskSwitchToReplicationRequest struct {
	DiskSwitchToReplicationRequest

	AsyncMode bool `url:"asyncMode"`
}

// DiskSwitchToReplication switches disk to it's replication
func (c Compute) DiskSwitchToReplication(ctx context.Context, req DiskSwitchToReplicationRequest) (bool, error) {
	err := validators.ValidateRequest(req)
	if err != nil {
		return false, validators.ValidationErrors(validators.GetErrors(err))
	}

	reqWrapped := wrapperDiskSwitchToReplicationRequest{
		DiskSwitchToReplicationRequest: req,
		AsyncMode:                      false,
	}

	url := "/cloudbroker/compute/diskSwitchToReplication"

	res, err := c.client.DecortApiCall(ctx, http.MethodPost, url, reqWrapped)
	if err != nil {
		return false, err
	}

	result, err := strconv.ParseBool(string(res))
	if err != nil {
		return false, err
	}

	return result, nil
}

// DiskSwitchToReplicationAsync switches disk to it's replication with AsyncMode
func (c Compute) DiskSwitchToReplicationAsync(ctx context.Context, req DiskSwitchToReplicationRequest) (string, error) {
	err := validators.ValidateRequest(req)
	if err != nil {
		return "", validators.ValidationErrors(validators.GetErrors(err))
	}

	reqWrapped := wrapperDiskSwitchToReplicationRequest{
		DiskSwitchToReplicationRequest: req,
		AsyncMode:                      true,
	}

	url := "/cloudbroker/compute/diskSwitchToReplication"

	res, err := c.client.DecortApiCall(ctx, http.MethodPost, url, reqWrapped)
	if err != nil {
		return "", err
	}

	return string(res), nil
}
